Subject: Re: Ethernet driver for Linux kernel 2.6 running on ML403

From: "David H. Lynch Jr." <[email-masked]>
Date: Thu, 14 Sep 2006 07:18:44 -0400

Grant Likely wrote:
> On 9/13/06, Aleck Lin <[email-masked]> wrote:
>   
>> Hi,
>>
>> I'm able to boot Linux 2.6 on ML403 board (with a ramdisk file system).
>>
>> However, during the kernel booting, it complains that "No network devices
>> available," So I figured I probably didn't enable the ethernet driver in the
>> kernel.
>>
>> >From doing "make menuconfig", under "Device Drivers" --> "Network device
>> support" --> "Ethernet(10 or 100Mbit)", I checked the box of both "Ethernet
>> (10 or 100Mbit)" and "PowerPC 4xx on-chip Ethernet support." I then
>> save/exit the menuconfig to compile the kernel again. I've attached the
>> error output at the bottom.
>>     
>
> The virtex eth device is not the same as 4xx on-chip Ethernet, so
> CONFIG_IBM_EMAC will not work.  You need the xilinx_enet driver (which
> is not in mainline).  It might be in MontaVista's 2.6 tree.
>
> I think people have posted patches for it to this list, so try
> searching the archives.  (I don't have a link off the top of my head.)
>   
    The MV 2.6 Xilinx_edk based TEMAC driver has been posted to this 
list several times.

    As of the last incarnation I tried it had no MII/PHY support and you 
had to manully change the speed of the driver 10/100/1000 by editing the 
code.
    Otherwise it worked with the PLB FIFO TEMAC, that I am using, and 
should with others.

    I have a polled driver that works with the LL TEMAC.
    I am nearly finished a PLB FIFO TEMAC driver that includes working 
autonegotiation and does not use the Xilinx_edk.
    But right now it has a receive problem - packets come in they look 
good but linux silently discards them.

    I have virtually the same code working under GHS Integrity.

-- 
Dave Lynch 					  	    DLA Systems
Software Development:  				         Embedded Linux
717.627.3770 	       [email-masked] 	  http://www.dlasys.net
fax: 1.253.369.9244 			           Cell: 1.717.587.7774
Over 25 years' experience in platforms, languages, and technologies too numerous to list.

"Any intelligent fool can make things bigger and more complex... It takes a touch of genius - and a lot of courage to move in the opposite direction."
Albert Einstein